/* 
 * Board.java
 * Aaron Mller (164750) und Beatrice Fischer (164718)
 */

import java.awt.Color;
import java.util.*;
import javax.swing.*;

public class Board {
	public Cube[][] cubes = new Cube[3][3];
	private static enum Angle {HORIZONTAL, VERTICAL};
	private int counter=0, counterUndo=0;
	private int rember[][] = new int[20][5];
	public IntFrame frame;
	
	Board(JPanel frame, IntFrame intF, int difficulty) {
		// Felder Anlegen
		for (int i=0; i<3; i++) {
			for (int ii=0; ii<3; ii++) {
				cubes[ii][i] = new Cube(ii, i, this);
				frame.add(cubes[ii][i]);
			}
		}	
		
		this.frame = intF;
		
		// Spielfeld generieren	
		if (this.frame.wt == 1) {
			this.generateGame(difficulty);
			this.gameDataToGUI();
		}
		
		if (this.frame.wt == 0) {
			this.gameDataToGUI();
		}
	}
	
	private void generateGame(int difficulty) {
		Random r = new Random();
		int new_rand;
		
		// Standard-Feld anlegen
		int[][] board = {
				{1, 2, 3, 4, 5, 6, 7, 8, 9},
				{4, 5, 6, 7, 8, 9, 1, 2, 3},
				{7, 8, 9, 1, 2, 3, 4, 5, 6},
				{2, 3, 4, 5, 6, 7, 8, 9, 1},
				{5, 6, 7, 8, 9, 1, 2, 3, 4},
				{8, 9, 1, 2, 3, 4, 5, 6, 7},
				{3, 4, 5, 6, 7, 8, 9, 1, 2},
				{6, 7, 8, 9, 1, 2, 3, 4, 5},
				{9, 1, 2, 3, 4, 5, 6, 7, 8}
		};
		
		// Modifikationen vornehmen
		new_rand = r.nextInt(5);
		for (int i=0; i<=new_rand; i++) // Horizontal spiegeln
			board = this.mirrorBoard(board, Angle.HORIZONTAL);
		
		new_rand = r.nextInt(5);
		for (int i=0; i<=new_rand; i++) // Vertikal spiegeln
			board = this.mirrorBoard(board, Angle.VERTICAL);		
		
		// 9 Zufallszahlen generieren
		int[] rand_numbers = new int[9];
		boolean stop = false;	// Zahl gefunden?
		
		for (int i=0; i<9; i++) {
			new_rand = r.nextInt(9) + 1;
			
			// Neue Zahl suchen
			while (!stop) {
				for (int n=0; n<9; n++) {
					if (rand_numbers[n] == new_rand) {
						new_rand = r.nextInt(9) + 1;
						stop = false;
						break;
					} else {
						stop = true;
					}
				}
			}
			
			stop = false;
			rand_numbers[i] = new_rand;
		}
		
		// Zahlen ersetzen
		int[][] new_solution = new int[9][9];
		
		for (int y=0; y<9; y++) {
			for (int x=0; x<9; x++) {
				new_solution[x][y] = rand_numbers[board[x][y]-1];
			}
		}
		
		// Zahlen lschen
		int[][] new_puzzle = new int[9][9];
		boolean del = false;
		int x, y; //, cx, cy;
		
		for (int i=0; i<difficulty; i++) {
			// Solange noch kein Feld gelscht wurde
			while (!del) {
				x = r.nextInt(9);
				y = r.nextInt(9);
				if (new_puzzle[x][y] != -1) {
					new_puzzle[x][y] = -1;
					del = true;
				}
			}
			del = false;
		}
		
		// Neues Board zuweisen
		if (frame.gameData.notInit == true) {
			frame.gameData.initGameData(new_solution, new_puzzle);
		}
		
		// Cheat-Modus :-)
		System.out.println(this.toString());
	}
	
	private int[][] mirrorBoard(int[][] board, Angle a) {
		int[][] b = new int[9][9];
		
		switch (a) {
			case HORIZONTAL: {
				for (int x=0; x<9; x++) {
					b[x] = board[8-x];
				}
			}
			break;
			case VERTICAL: {
				for (int x=0; x<9; x++) {
					for (int y=0; y<9; y++) {
						b[x][y] = board[8-x][y];
					}
				}
			}
		}
		
		return b;
	}
	
	public void gameDataToGUI() {
		for (int cy=0; cy<3; cy++) {
			for (int cx=0; cx<3; cx++) {	
				// Fr jeden Cube
				for (int y=0; y<3; y++) {
					for (int x=0; x<3; x++) {
						if (frame.gameData.isFixed((cx*3)+x, (cy*3)+y)) {
							cubes[cx][cy].cubeFields[x][y].setInitialNumber(
								frame.gameData.getNumber((cx*3)+x, (cy*3)+y));
						} else {
							// Editor? Alles anzeigen
							if (this.frame.wt == 2) {
							cubes[cx][cy].cubeFields[x][y].setNumber(
								frame.gameData.getNumber((cx*3)+x, (cy*3)+y));
							// Normales Spiel? Nur die schon gelsten anzeigen
							} else {
								if (frame.gameData.puzzle[(cx*3)+x][(cy*3)+y] != -1) {
									cubes[cx][cy].cubeFields[x][y].setNumber(
										frame.gameData.puzzle[(cx*3)+x][(cy*3)+y]);
									if (frame.gameData.puzzle[(cx*3)+x][(cy*3)+y] !=
										frame.gameData.getNumber((cx*3)+x, (cy*3)+y)) {
										cubes[cx][cy].cubeFields[x][y].setImpossible(true);
									}	
								}
							}
						}
					}
				}
			}
		}
	}
	
	public void GUIToGameData() {
		for (int cy=0; cy<3; cy++) {	
			for (int cx=0; cx<3; cx++) {
				
				// Fr jeden Cube
				for (int y=0; y<3; y++) {
					for (int x=0; x<3; x++) {
						if (cubes[cx][cy].cubeFields[x][y].getBackground() == Color.WHITE) {
						frame.gameData.setNumber((cx*3)+x, (cy*3)+y, 
								cubes[cx][cy].cubeFields[x][y].getNumber());
						
						// Editor?
						if (this.frame.wt == 2) {
							frame.gameData.setSolutionNumber((cx*3)+x, (cy*3)+y, 
									cubes[cx][cy].cubeFields[x][y].getNumber());
						}
						// Festes Kstchen?
						} else if (cubes[cx][cy].cubeFields[x][y].getBackground() == Color.LIGHT_GRAY) {
							frame.gameData.setNumber((cx*3)+x, (cy*3)+y, 
									cubes[cx][cy].cubeFields[x][y].getNumber());
							// Editor?
							if (this.frame.wt == 2) {
								frame.gameData.setSolutionNumber((cx*3)+x, (cy*3)+y, 
										cubes[cx][cy].cubeFields[x][y].getNumber());
								frame.gameData.setFixed((cx*3)+x, (cy*3)+y, true);
							}
						} else {
							frame.gameData.setNumber((cx*3)+x, (cy*3)+y, -1);
							// Editor?
							if (this.frame.wt == 2) {
								frame.gameData.setSolutionNumber((cx*3)+x, (cy*3)+y, -1);
							}
						}
					}
				}
			}
		}
	}
	
	public void checkNumber(Field f, int n) {
		// Normales Spiel?
		if (this.frame.wt <= 1 && n != -1) {
			if (n != 
				frame.gameData.getNumber((f.cube.posX*3)+f.posX, (f.cube.posY*3)+f.posY)) {
				f.setImpossible(true);
			} else {
				f.setImpossible(false);
			}
		}
	}
	
	public void updateUndo(Field f, int n) {
		// Fr UNDO
		for (int i = counter; i>0; i--) {
			// Werte um eins nach "hinten" verschieben
			rember[10+i][0] = rember[10+i-1][0];
			rember[10+i][1] = rember[10+i-1][1];
			rember[10+i][2] = rember[10+i-1][2];
			rember[10+i][3] = rember[10+i-1][3];
			rember[10+i][4] = rember[10+i-1][4];
		}
		
		// aktuelle Eingabe in Array an Stelle 10 schreiben
		rember[10][0] = n;
		rember[10][1] = f.cube.posX;
		rember[10][2] = f.cube.posY;
		rember[10][3] = f.posX;
		rember[10][4] = f.posY;		
		
		counterUndo++;
		if (counter > 4) {
			counter = 5;
		}else {
			counter++;	
		}
	}
	
	public boolean isPuzzleSolved() {
		for (int cy=0; cy<3; cy++) {	
			for (int cx=0; cx<3; cx++) {
				
				// Fr jeden Cube
				for (int y=0; y<3; y++) {
					for (int x=0; x<3; x++) {
						if (cubes[cx][cy].cubeFields[x][y].getNumber() != 
							this.frame.gameData.getNumber((cx*3)+x, (cy*3)+y)) {
							return false;
						}
					}
				}
			}
		}
		
		return true;
	}
	
	public String toString() {
		String out = "";
		for (int y=0; y<9; y++) {
			for (int x=0; x<9; x++) {
				out += frame.gameData.getNumber(x, y) + ", ";
			}
			out += "\n";
		}
		
		return out;
	}
	
	public void unDo(){
		
		if (counterUndo>0) {
			// Feld leeren
			this.frame.board.cubes[rember[10][1]][rember[10][2]].cubeFields[rember[10][3]][rember[10][4]].setNumber(-1);
			// Hintergundfarbe auf wei ndern
			this.frame.board.cubes[rember[10][1]][rember[10][2]].cubeFields[rember[10][3]][rember[10][4]].setColor(Color.WHITE);
		}
		
		for (int i = -1; i<= counter; i++) {
			// Werte um eins nach "vorne" verschieben
			rember[10+i][0] = rember[10+i+1][0];
			rember[10+i][1] = rember[10+i+1][1];
			rember[10+i][2] = rember[10+i+1][2];
			rember[10+i][3] = rember[10+i+1][3];
			rember[10+i][4] = rember[10+i+1][4];	
		}	
		counterUndo--;
	}
}
