/* 
 * Cube.java
 * Aaron Mller (164750) und Beatrice Fischer (164718)
 */

import java.awt.*;
import javax.swing.*;

public class Cube extends JPanel {
	private static final long serialVersionUID = 1L;
	public Field[][] cubeFields = new Field[3][3];
	
	public int posX, posY;	// Position auf dem Spielbrett
	public Board board;		// Assoziation

	Cube(int posX, int posY, Board board) {
		this.posX = posX;
		this.posY = posY;
		this.board = board;
		
		// Layout manager setzen
		setLayout(new GridLayout(3, 3));
		
		// Felder anlegen
		for (int i=0; i<3; i++) {
			for (int ii=0; ii<3; ii++) {
				cubeFields[ii][i] = new Field(ii, i, this);
				add(cubeFields[ii][i]);
			}
		}
		
		// Sichtbar machen
		setVisible(true);
	}
	
	public boolean isInRow(int r, int n) {
		for (int i=0; i<3; i++) {
			if (this.cubeFields[r][i].getNumber() == n) {
				return true;
			}
		}
		return false;
	}
	
	public boolean isInColumn(int c, int n) {
		for (int i=0; i<3; i++) {
			if (this.cubeFields[i][c].getNumber() == n) {
				return true;
			}
		}
		return false;		
	}
	
	public boolean isInCube(int n) {
		for (int y=0; y<3; y++) {
			for (int x=0; x<3; x++) {
				if (this.cubeFields[x][y].getNumber() == n) {
					return true;
				}
			}
		}
		
		return false;
	}
}
