/* 
 * GameData.java
 * Aaron Mller (164750) und Beatrice Fischer (164718)
 */

import java.io.Serializable;

public class GameData implements Serializable {	
	private static final long serialVersionUID = 1L;
	
	String[][] solution = new String[9][9]; // Lsung
	int[][] puzzle = new int[9][9];			// Schon eingegebenes Puzzle
	boolean notInit;						// Keine initialisierung (Editor)
	
	GameData() {
		notInit = true;
	}
	
	GameData(int[][] solution, int[][] puzzle) {
		this.initGameData(solution, puzzle);
	}
	
	public void initGameData(int[][] solution, int[][] puzzle) {
		for (int y=0; y<9; y++) {
			for (int x=0; x<9; x++) {
				this.solution[x][y] = 
					((puzzle[x][y] == -1) ? "v_" : "f_") + solution[x][y];
			}
		}
		
		this.puzzle = puzzle;
		notInit = false;
	}
	
	public int getNumber(int x, int y) {
		return Integer.parseInt(this.solution[x][y].substring(2));
	}
	
	public void setNumber(int x, int y, int n) {
		this.puzzle[x][y] = n;
	}
	
	public void setSolutionNumber(int x, int y, int n) {
		this.solution[x][y] = "v_" + n;
	}
	
	public void setFixedSolutionNumber(int x, int y, int n) {
		this.solution[x][y] = "f_" + n;
	}
	
	public void setFixed(int x, int y, boolean f) {
		String n = this.solution[x][y].substring(2);
		this.solution[x][y] = (f) ? "f_" + n : "v_" + n;
	}
	
	public boolean isFixed(int x, int y) {
		return (this.solution[x][y].substring(0, 2).equals("f_")) ? true : false;
	}
	
	public boolean isPuzzleSolved() {
		for (int y=0; y<9; y++) {
			for (int x=0; x<9; x++) {
				if (this.isFixed(x, y) != true && this.puzzle[x][y] == -1) {
					return false;
				}
			}
		}
		
		return true;
	}
	
	public String toString() {
		String out = "Solution:\n";
		for (int y=0; y<9; y++) {
			for (int x=0; x<9; x++) {
				out += this.solution[x][y] + ", ";
			}
			out += "\n";
		}
		
		out += "\nPuzzle:\n";
		for (int y=0; y<9; y++) {
			for (int x=0; x<9; x++) {
				out += this.puzzle[x][y] + ", ";
			}
			out += "\n";
		}
		
		return out;
	}
}
