/* 
 * SuDoKu.java
 * Aaron Mller (164750) und Beatrice Fischer (164718)
 */

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.ArrayList;
import javax.swing.*;

import tools.Konsole;

public class SuDoKu extends JApplet implements ActionListener {
	private static final long serialVersionUID = 1L;
	private JDesktopPane desk;
	
	final ImageIcon // Hintergrundbild
		background = new ImageIcon(getClass().getResource("images/background.png"));
	
	private Icon 	// Men-Icons
		iconMenuNew = new ImageIcon(getClass().getResource("images/menu_new.png")),
		iconMenuOpen = new ImageIcon(getClass().getResource("images/menu_open.png")),
		iconMenuEditor = new ImageIcon(getClass().getResource("images/menu_editor.png")),
		iconMenuExit = new ImageIcon(getClass().getResource("images/menu_exit.png")),
		iconMenuInfo = new ImageIcon(getClass().getResource("images/menu_info.png")),
		iconMenuTeam = new ImageIcon(getClass().getResource("images/menu_team.png")),
		iconMenuEasy = new ImageIcon(getClass().getResource("images/menu_game_easy.png")),
		iconMenuMiddle = new ImageIcon(getClass().getResource("images/menu_game_normal.png")),
		iconMenuExpert = new ImageIcon(getClass().getResource("images/menu_game_hard.png"));
	
	private static JMenuBar menuBar = new JMenuBar();
	
	private static JMenu menuGenerateGame = new JMenu("Neues Spiel generieren");
	private static JMenuItem[] menuGenerateItemGame = {
		new JMenuItem("Leicht"),
		new JMenuItem("Mittel"),
		new JMenuItem("Schwer")};	
	
	//private static JMenu menuChooseGame = new JMenu("Neues Spiel generieren");
	private static JMenu menuChoosePuzzle = new JMenu("Spiel whlen");
	private static JMenu menuGame = new JMenu("Spiel");
	private static JMenuItem[] menuItemsGame = {
		new JMenuItem("Spielstand laden"),
		new JMenuItem("Editor"),
		new JMenuItem("Beenden")
	};

	private static JMenu menuHelp = new JMenu("Hilfe");
	private static JMenuItem[] menuItemsHelp = {
		new JMenuItem("Information"),
		new JMenuItem("ber ...")
	};
	
	static SuDoKu desktop = new SuDoKu();
	private JFileChooser openDialog = new JFileChooser(new File("./"));
	
	public SuDoKu() {
		desk = new JDesktopPane() {
			private static final long serialVersionUID = 1L;
			
			// Hintergrundbild zeichnen
			public void paintComponent(Graphics g) {
				super.paintComponent(g);
				g.drawImage(background.getImage(), 0, 0, this);
			}
		};
		
		desk.setDesktopManager(new DefaultDesktopManager());
		setContentPane(desk);
		initRootWindow();
		
		desk.setBackground(Color.BLACK);
	}

	public static void main(String[] args) {
		Konsole.run(desktop, 500, 500);
	}
	
	// Neues Spiel erstellen
	private void addWindow(int wt, int difficulty) {
		GameData gd = new GameData();
		IntFrame f = new IntFrame(this, wt, difficulty, gd);
		f.setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);
		this.add(f);
		f.setVisible(true);
	}
	
	// Geladenes Spiel wiederherstellen
	private void addLoadedWindow(GameData gd) {
		IntFrame f = new IntFrame(this, 0, -1, gd);
		f.setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);
		this.add(f);
		f.setVisible(true);
		
		// Debug
		//System.out.println(f.gameData.toString());
	}
	
	private void initRootWindow() {
		// Icons setzen
		menuItemsGame[0].setIcon(iconMenuOpen);
		menuItemsGame[1].setIcon(iconMenuEditor);
		menuItemsGame[2].setIcon(iconMenuExit);
		
		menuItemsHelp[0].setIcon(iconMenuInfo);
		menuItemsHelp[1].setIcon(iconMenuTeam);
		
		menuGenerateGame.setIcon(iconMenuNew);
		menuGenerateItemGame[0].setIcon(iconMenuEasy);
		menuGenerateItemGame[1].setIcon(iconMenuMiddle);
		menuGenerateItemGame[2].setIcon(iconMenuExpert);
		
		menuChoosePuzzle.setIcon(iconMenuOpen);
		
		// Aktionsbefehle
		menuItemsGame[0].setActionCommand("mLoad");
		menuItemsGame[1].setActionCommand("mEditor");
		menuItemsGame[2].setActionCommand("mExit");
		menuItemsHelp[0].setActionCommand("mInfo");
		menuItemsHelp[1].setActionCommand("mTeam");
		menuGenerateItemGame[0].setActionCommand("mEasy");
		menuGenerateItemGame[1].setActionCommand("mMiddle");
		menuGenerateItemGame[2].setActionCommand("mExpert");
		
		// Action-Listener
		menuItemsGame[0].addActionListener(this);
		menuItemsGame[1].addActionListener(this);
		menuItemsGame[2].addActionListener(this);
		menuItemsHelp[0].addActionListener(this);
		menuItemsHelp[1].addActionListener(this);
		menuGenerateItemGame[0].addActionListener(this);
		menuGenerateItemGame[1].addActionListener(this);
		menuGenerateItemGame[2].addActionListener(this);
		
		// Mens zusammenbauen
		menuGame.add(menuGenerateGame);
		menuGenerateGame.add(menuGenerateItemGame[0]);
		menuGenerateGame.add(menuGenerateItemGame[1]);
		menuGenerateGame.add(menuGenerateItemGame[2]);
		
		menuGame.add(menuChoosePuzzle);
		
		// Hier die dynamische hinzufgung
		this.generatePuzzleMenu();
		
		menuGame.add(menuItemsGame[0]);
		menuGame.add(menuItemsGame[1]);
		menuGame.addSeparator();
		menuGame.add(menuItemsGame[2]);
		
		menuHelp.add(menuItemsHelp[0]);
		menuHelp.add(menuItemsHelp[1]);
		
		// Menbar fllen
		menuBar.add(menuGame);
		menuBar.add(menuHelp);
		this.setJMenuBar(menuBar);
	}
	
	// Dynamisches Men erstellen
	public void generatePuzzleMenu() {
		// Verzeichnis auslesen
		String entries[] = new File(".").list(); // TODO: Evtl noch ein anderes Verzeichnis
		//System.out.println( Arrays.asList(entries) );
		
		// Meneintrge anlegen
		ArrayList<JMenuItem> files = new ArrayList<JMenuItem>();
		for (int i=0; i<entries.length; i++) {
			if (entries[i].endsWith(".sudoku")) {
				files.add(new JMenuItem(entries[i].substring(0,entries[i].length()-7)));
			}
		}
		
		// Ins Men eintragen, Action-Listener anlegen, ...
		JMenuItem[] menuChoosePuzzleItems = new JMenuItem[files.size()];
		for (int i=0; i<files.size(); i++) {
			menuChoosePuzzleItems[i] = files.get(i);
			menuChoosePuzzle.add(menuChoosePuzzleItems[i]);
			menuChoosePuzzleItems[i].addActionListener(this);
			menuChoosePuzzleItems[i].setActionCommand("mLoadPuzzle");
			menuChoosePuzzleItems[i].setIcon(iconMenuNew);
		}
		
	}

	//@SuppressWarnings("deprecation")
	public void actionPerformed(ActionEvent e) {
		String a = e.getActionCommand();
		
		// Neues Spiel starten
		
		// Einfach
		if (a.equals("mEasy")) {
			desktop.addWindow(1, 45);
		}
		// Mittel
		if (a.equals("mMiddle")) {
			desktop.addWindow(1, 49);
		}
		// Schwer
		if (a.equals("mExpert")) {
			desktop.addWindow(1, 53);
		}
		
		// Vorgefertigtes Level aus dem Men laden
		if (a.equals("mLoadPuzzle")) {
			String filename = ((JMenuItem)e.getSource()).getText() + ".sudoku";
			
			try {
				FileInputStream fs = new FileInputStream(filename);
				ObjectInputStream os = new ObjectInputStream(fs);
				GameData gd = (GameData)os.readObject();
				this.addLoadedWindow(gd);
				os.close();
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
		
		// Gespeichertes Spiel laden
		if (a.equals("mLoad")) {
			openDialog.setFileSelectionMode(JFileChooser.FILES_ONLY);
			int res_file = openDialog.showOpenDialog(this);
			if (res_file == JFileChooser.APPROVE_OPTION) {
				String filename = "" + openDialog.getSelectedFile().getName();
				
				try {
					// Laden
					FileInputStream fs = new FileInputStream(filename);
					ObjectInputStream os = new ObjectInputStream(fs);

					GameData gd = (GameData)os.readObject();
					this.addLoadedWindow(gd);
					os.close();
					
				} catch (Exception ex) {
					ex.printStackTrace();
				}
			}
		}
		
		// Editor Starten
		if (a.equals("mEditor")) {
			desktop.addWindow(2, -1);
		}
		
		// Programm beenden
		if (a.equals("mExit")) {
			System.exit(1);
		}
		
		// Hilfe
		
		// Information
		if (a.equals("mInfo")) {
			Information info = new Information();
			info.setVisible(true);
		}		
		
		if (a.equals("mTeam")) {
			JOptionPane.showMessageDialog(this,
				    "von Aaron Mller (164750) und Beatrice Fischer (164718)",
				    "ber", JOptionPane.PLAIN_MESSAGE);
		}
		
	}
}
